#include <stdio.h>

int main()
{
	int* PinnedMermoyIn;
	int* PinnedMermoyOut;
	
	int* DeviceMemory;
	
	cudaMallocHost((void**)&PinnedMermoyIn, 5*sizeof(int));
	cudaMallocHost((void**)&PinnedMermoyOut, 5*sizeof(int));
	
	for( int i = 0; i < 5; i++)
	{
		PinnedMermoyIn[i] = i;
	}

	cudaMalloc((void**)&DeviceMemory, 5*sizeof(int));
	
	cudaMemcpy(DeviceMemory, PinnedMermoyIn, 5*sizeof(int), cudaMemcpyHostToDevice);

	cudaMemcpy(PinnedMermoyOut, DeviceMemory, 5*sizeof(int), cudaMemcpyDeviceToHost);
	
	for( int i = 0; i < 5; i++)
	{
		printf(" OutputData[%d] : %d\n",i,PinnedMermoyOut[i]);
	}
	
	cudaFreeHost(PinnedMermoyIn);
	cudaFreeHost(PinnedMermoyOut);
	cudaFree(DeviceMemory);

	return 0;
}