#include <stdio.h>
#include <stdlib.h>

#define N  1000		//1000X1000 Ļ

//level3 32bit Ǽ gemm 
void sgemm(int n, float alpha, const float *A, const float *B, float beta, float *C)
{
    int i = 0;
    int j = 0;
    int k = 0;
    for (i = 0; i < n; ++i) {
        for (j = 0; j < n; ++j) {
            float prod = 0;
            for (k = 0; k < n; ++k) {
                prod += A[k * n + i] * B[j * n + k];
            }
            C[j * n + i] = alpha * prod + beta * C[j * n + i];
        }
    }
}

int main(int argc, char** argv)
{    
    float* A;
    float* B;
    float* C;

	float alpha = 2.0f;
    float beta = 3.0f;
    int n2 = N * N;
    int i = 0;

	// ޸ Ҵ
    A = (float*)malloc(n2 * sizeof(float));
	B = (float*)malloc(n2 * sizeof(float));
	C = (float*)malloc(n2 * sizeof(float));

	//   ʱȭ
	for (i = 0; i < n2; i++) {
        A[i] = rand() / (float)RAND_MAX;
        B[i] = rand() / (float)RAND_MAX;
        C[i] = rand() / (float)RAND_MAX;
    }

	//32bit Ǽ gemm 
    sgemm(N, alpha, A, B, beta, C);
    
	//޸ 
    free(A);
    free(B);
    free(C);
    
    return true;
}
