#include <cufft.h>

#define NX 256
#define NY 128

int main()
{
	cufftHandle plan;
	cufftComplex *idata, *odata;
	
	cudaMalloc((void**)&idata, sizeof(cufftComplex)*NX*NY);
	cudaMalloc((void**)&odata, sizeof(cufftComplex)*NX*NY);
	
	//2D FFT plan 
	cufftPlan2d(&plan, NX, NY, CUFFT_C2C);
	
	//ñ׳  ȯ
	cufftExecC2C(plan, idata, odata, CUFFT_FORWARD);
	
	//ñ׳  ȯ
	cufftExecC2C(plan, odata, odata, CUFFT_INVERSE);
	
	//2D FFT plan Ҹ
	cufftDestroy(plan);

	cudaFree(idata);
	cudaFree(odata);

	return true;
}