#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//cublas ش Ŭ
#include "cublas.h"

#define N  1000	//1000x1000 

int main(int argc, char** argv)
{    
	float* h_A;
	float* h_B;
	float* h_C;

	float* d_A = 0;
	float* d_B = 0;
	float* d_C = 0;

	float alpha = 1.0f;
	float beta = 0.0f;
	int n2 = N * N;
	int i=0;

	/* Initialize CUBLAS */
	cublasInit();

	//ȣƮ ޸ Ҵ
	h_A = (float*)malloc(n2 * sizeof(float));
	h_B = (float*)malloc(n2 * sizeof(float));
	h_C = (float*)malloc(n2 * sizeof(float));

	//  ʱȭ
	for (i = 0; i < n2; i++) {
		h_A[i] = rand() / (float)RAND_MAX;
		h_B[i] = rand() / (float)RAND_MAX;
		h_C[i] = rand() / (float)RAND_MAX;
	}

	// ̽ ޸ Ҵ
	cublasAlloc(n2, sizeof(float), (void**)&d_A);
	cublasAlloc(n2, sizeof(float), (void**)&d_B);
	cublasAlloc(n2, sizeof(float), (void**)&d_C);

	// ̽ ޸𸮿 Ʈ  
	cublasSetVector(n2, sizeof(float), h_A, 1, d_A, 1);
	cublasSetVector(n2, sizeof(float), h_B, 1, d_B, 1);
	cublasSetVector(n2, sizeof(float), h_C, 1, d_C, 1);

	//cublas 32bit Ǽ gemm 
	cublasSgemm('n', 'n', N, N, N, alpha, d_A, N, d_B, N, beta, d_C, N);

	// 
	cublasGetVector(n2, sizeof(float), d_C, 1, h_C, 1);

	//޸ 
	free(h_A);
	free(h_B);
	free(h_C);

	cublasFree(d_A);
	cublasFree(d_B);
	cublasFree(d_C);

	// cublas 
	cublasShutdown();

	return true;
}
